
-- return the window size
getWindowSize = getWindowSize or function()
	if showTestSignals then
		return 700, 155
	end
	return 650, 155
end

-- create and lay out all the controls
createUI = createUI or function()

	createUICommon()

	-- constants
	local kKnobSpace = 43
	local kWideTextW = 40

	-- make groups and knobs
	--
	
	local x = 0

	theKnobRenderer = smallKnobRenderer

	targetGroup = group( "Target" )
	x = 0
	labelledDropDown( targetGroup, "Target Hardware", "Hardware",	x, 0 )
	x = x + kDropdownW + pad
	labelledDropDown( targetGroup, "Target Channel", "Channel",		x, 0 )
	x = x + kDropdownW + pad

	inputsGroup = group( "Inputs" )
	local kInputsW = 40
	local kInputsY = kTextFieldH + 20
	x = 0
	labelledDropDown( inputsGroup, "Input Thru", "Thru",		x, kInputsY, kInputsW )
	x = x + kInputsW + 10
	labelledDropDown( inputsGroup, "Input 1", "1",		x, kInputsY, kInputsW )
	inputsGroup:add( paramButton( "Filter 1", "Filter",	x, 0, kInputsW, kTextFieldH ) )
	x = x + kInputsW + 10
	labelledDropDown( inputsGroup, "Input 2", "2",		x, kInputsY, kInputsW )
	inputsGroup:add( paramButton( "Filter 2", "Filter",	x, 0, kInputsW, kTextFieldH ) )
	x = x + kInputsW + 10
	labelledDropDown( inputsGroup, "Input 3", "3",		x, kInputsY, kInputsW )
	inputsGroup:add( paramButton( "Filter 3", "Filter",	x, 0, kInputsW, kTextFieldH ) )
	x = x + kInputsW + 10
	labelledDropDown( inputsGroup, "Input 4", "4",		x, kInputsY, kInputsW )
	inputsGroup:add( paramButton( "Filter 4", "Filter",	x, 0, kInputsW, kTextFieldH ) )
	x = x + kInputsW + 10

	miscGroup = group( "Misc" )
	x = 0
	smallKnobAndTextField( miscGroup, "Test Signal",	"Test",		x, 0 )
	miscGroup:setVisible( showTestSignals )

	interfaceGroup = group( "Interface" )
	x = 0
	labelledDropDown( interfaceGroup, "Interface Category", "Category",		x, 0 )

	oscGroup = group( "OSC" )
	smallKnobAndTextField( oscGroup, "OSC Port Offset",	"Port",		0*kKnobSpace, 0 )
	oscGroup:setVisible( false )

	offsetsGroup = group( "Offsets" )
	x = 0
	for i=1,4 do
		knobAndTextField( offsetsGroup, "Offset " .. i,		"" .. i,		x, 0, kKnobSize, kTextFieldH, kWideTextW, "%.3f" )
		x = x + kWideTextW + pad
	end

	-- positions!

	local xbase = windowEdgePad
	local ybase = windowEdgePad
	local x = xbase
	local y = ybase

	interfaceGroup:setPosition( x, y, true )
	y = y + interfaceGroup:height() + pad

	targetGroup:setPosition( x, y, true )
	local top = y + targetGroup:height()
	x = x + targetGroup:width() + pad

	y = ybase
	inputsGroup:setPosition( x, top - inputsGroup:height(), true )
	x = x + inputsGroup:width() + pad

	offsetsGroup:setPosition( x, top - offsetsGroup:height(), true )
	x = x + offsetsGroup:width() + pad

	miscGroup:setPosition( x, y, true )

	x = xbase
	y = ybase
	x = x + interfaceGroup:width() + pad

	-- add directly positioned objects
	--
	
	x = xbase + interfaceGroup:width() + pad
	y = ybase + 12
	add( paramButton( "SMUX Proof", "SMUX Proof",	x, y, 100, kTextFieldH ) )

end		-- of createUI()
